//========================================================================================================================================================================//
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//========================================================================================================================================================================//
extern int ma1 =6;
extern int ma2 =18;
extern int ma3 =50;
extern int ma4 =200;

extern double sl=10.0;
extern double tp=20.0;
extern double risk=10.0;
//========================================================================================================================================================================//
int minbar =ma1;
int canbuy;
int cansell;
bool crossup=false;
bool crossdown=false;
double swinghigh,swinglow;
int swinghighattempts,swinglowattempts,pullbackhighattampt,pullbacklowattampt;
//double  openprice;
bool checkbuycondition=false;
bool checksellcondition=false;
bool swinghfound,swinglfound;
double highestprevbar,currentcandleh,lowestprevbar,currentcandlel;
//========================================================================================================================================================================//
int OnInit()
  {

   return(INIT_SUCCEEDED);
  }
//========================================================================================================================================================================//
void OnDeinit(const int reason)
  {

  }
//========================================================================================================================================================================//
void OnTick()
  {  
//===============================================================================================================================  
if (isthisthisnewcandle()){ 
       isthereactiveorder();
       cheackmacross();
       drawlabel(0,"buy0",24,109,CORNER_LEFT_UPPER,StringConcatenate(" canbuy="+canbuy+" crossup="+crossup),10,Aqua,true,false); 
       drawlabel(0,"sell0",29,178,CORNER_LEFT_UPPER,StringConcatenate(" cansell="+cansell+" crossdown="+crossdown),10,Aqua,true,false); 


//============================================================================================   
    if(crossup==true && canbuy==0){
        ArrowCreate(OBJ_ARROW_UP,"ab",Time[1],Low[1]+(100*Point),0,clrWhite,2,true,true,true,0);
        checkbuycondition=true;
}
    if(checkbuycondition==true){   
        swinghighattempts++;
        drawlabel(0,"checkbuycondition",299,173,CORNER_LEFT_UPPER,StringConcatenate("checkbuycondition="+checkbuycondition),15,Aqua,true,false); 
        drawlabel(0,"CROSS UP",666,318,CORNER_LEFT_UPPER,StringConcatenate("CROSS UP "+""),15,Aqua,true,false); 
        drawlabel(0,"swing h to be checked1",374,15,CORNER_LEFT_UPPER,StringConcatenate("this is swing high candle "+isthiscandleswingh()+" becaue the curr high is "+currentcandleh),15,DarkOrange,true,false); 
        drawlabel(0,"swing h to be checked2",1209,16,CORNER_LEFT_UPPER,StringConcatenate(" and highest candle in range of 8 "+highestprevbar),15,DarkOrange,true,false); 
          }
    if(swinghighattempts<=2 && swinghighattempts>0){      
        drawlabel(0,"swinghighattempts",922,315,CORNER_LEFT_UPPER,StringConcatenate("swinghighattempts="+swinghighattempts),15,MediumSpringGreen,true,false); 
        }
    if(pullbackhighattampt<3 && pullbackhighattampt>0){      
        drawlabel(0,"pullbackhighattampt",1157,315,CORNER_LEFT_UPPER,StringConcatenate("pullbackhighattampt="+pullbackhighattampt),15,clrYellow,true,false); 
        }
    if(swinghighattempts<=2 && isthiscandleswingh()==true){
    swinghigh=High[1];
    swinghfound=true;
    }
    if(swinghighattempts>2)
      {
       checkbuycondition=false;
      }
    if(swinghfound==true)
      {
       if(High[1]<swinghigh)
         {
          if(isthispullbackh)
            {
             pullbackhighattampt++;
            }
          if(pullbackhighattampt>3)
            {
             swinghfound=false;
            }
          if(pullbackhighattampt<=3 && Close[1]>iMA(Symbol(),0,ma3,0,MODE_EMA,PRICE_CLOSE,1))
            {
              if(canbuy==0)
                {
                opennew(OP_BUYSTOP);
                }
            }
         }
      }
     if(checkbuycondition==false)
       {
        del("CROSS UP");
        del("swinghighattempts");
        del("swing h to be checked1");
        del("swing h to be checked2");
        del("checkbuycondition");
        del("arrowuph");         
        del("arrowupch");
        del("ab");
        del("pullbackhighattampt");
        del("CROSS UP"); 
       }  
       
//================================================================================================================           
    if(crossdown==true && cansell==0){
        ArrowCreate(OBJ_ARROW_DOWN,"as",Time[1],High[1]+(100*Point),0,clrWhite,2,true,true,true,0);
        checksellcondition=true;  }
    if(checksellcondition==true){   
        swinglowattempts++;
        drawlabel(0,"CROSS DOWN",666,318,CORNER_LEFT_UPPER,StringConcatenate("CROSS DOWN"+""),15,MediumSpringGreen,true,false); 
        drawlabel(0,"checksellcondition",299,173,CORNER_LEFT_UPPER,StringConcatenate("checksellcondition="+checksellcondition),15,Aqua,true,false); }
    if(swinglowattempts<=2 ){      
        drawlabel(0,"swinghighattempts",922,315,CORNER_LEFT_UPPER,StringConcatenate("swinghighattempts="+swinghighattempts),15,MediumSpringGreen,true,false); 
        }
    if( pullbacklowattampt<=3 ){      
        drawlabel(0,"pullbackhighattampt",1157,315,CORNER_LEFT_UPPER,StringConcatenate("pullbackhighattampt="+pullbackhighattampt),15,clrYellow,true,false); 
        }
    if(swinglowattempts>2)
      {
       checksellcondition=false;
      }
    if(swinglowattempts<=2 && isthiscandleswingl()==true){
    swinglow=Low[1];
    swinglfound=true;
    }
    if(swinglfound==true)
      {
       if(Low[1]>swinglow)
         {
          if(isthispullbackl)
            {
             pullbacklowattampt++;
            }
          if(pullbacklowattampt>3)
            {
             swinglfound=false;
            }
          if(pullbacklowattampt<=3 && Close[1]>iMA(Symbol(),0,ma3,0,MODE_EMA,PRICE_CLOSE,1))
            {
              opennew(OP_SELLSTOP);
            }
         }
      }
     if(checkbuycondition==false)
       {
        del("CROSS UP");
        del("swinghighattempts");
        del("swing h to be checked1");
        del("swing h to be checked2");
        //del("checkbuycondition");
        del("arrowuph");         
        del("arrowupch");
        del("ab");
        del("pullbackhighattampt");
        del("CROSS UP"); 
       }
    if(checksellcondition==false){
        del("CROSS DOWN");
        del("swinglowattempts");
        del("swing l to be checked1");
        del("swing l to be checked2");
        //del("checksellcondition");
        del("arrowdownl");
        del("arrowdowncl");
        del("as");
        del("pullbacklowattampt");
        del("CROSS UP");
        del("pullback h to be checked1");
    }
   }     
       }
/*============================================================================================   
    if( checkbuycondition==true && canbuy==0  )
        {  
            drawlabel(0,"swing h to be checked1",374,15,CORNER_LEFT_UPPER,StringConcatenate("this is swing high candle "+isthiscandleswingh()+" becaue the curr high is "+currentcandleh),15,DarkOrange,true,false); 
            drawlabel(0,"swing h to be checked2",1209,16,CORNER_LEFT_UPPER,StringConcatenate(" and highest candle in range of 8 "+highestprevbar),15,DarkOrange,true,false); 
            drawlabel(0,"pullback h to be checked1",382,61,CORNER_LEFT_UPPER,StringConcatenate("this is pull back "+isthispullbackh()),15,DarkOrange,true,false); 
            ArrowCreate(OBJ_ARROW_UP,"arrowuph",Time[iHighest(Symbol(),0,MODE_HIGH,8,1)],High[iHighest(Symbol(),0,MODE_HIGH,8,1)]-(70*Point),0,clrAqua,3,true,true,true,0);     
            ObjectMove("arrowuph",ANCHOR_LEFT_UPPER,Time[iHighest(Symbol(),0,MODE_HIGH,8,1)],High[iHighest(Symbol(),0,MODE_HIGH,8,1)]);
            if (swinghighattempts<=10 && pullbacklowattampt<=10)
               { 
               ArrowCreate(OBJ_ARROW_UP,"arrowupch",Time[1],High[1]-(70*Point),0,clrGold,3,true,true,true,0);
               opennew(OP_BUYSTOP);}
                        
               }
//============================================================================================
    if(cansell==0 && checksellcondition==true )
        {
            drawlabel(0,"swing l to be checked1",374,15,CORNER_LEFT_UPPER,StringConcatenate("this is swing low candle "+isthiscandleswingl()+" becaue the curr low is "+currentcandlel),15,DarkOrange,true,false); 
            drawlabel(0,"swing l to be checked2",1209,16,CORNER_LEFT_UPPER,StringConcatenate(" and lowest candle in range of 8 "+lowestprevbar),15,DarkOrange,true,false); 
            ArrowCreate(OBJ_ARROW_DOWN,"arrowdownl",Time[iLowest(Symbol(),0,MODE_LOW,8,1)],Low[iLowest(Symbol(),0,MODE_LOW,8,1)]+(70*Point),0,clrAqua,3,true,true,true,0);
            ObjectMove("arrowdownl",ANCHOR_LEFT_UPPER,Time[iLowest(Symbol(),0,MODE_LOW,8,1)],Low[iLowest(Symbol(),0,MODE_LOW,8,1)]);
            if(pullbacklowattampt<=10 && pullbacklowattampt<=10){
            ArrowCreate(OBJ_ARROW_DOWN,"arrowdowncl",Time[1],Low[1]+(70*Point),0,clrGold,3,true,true,true,0);
            opennew(OP_SELLSTOP);
                       }
        }
  }
  }
  
  
//=============================================================================================================================== 
//========================================================================================================================================================================//
*/void isthereactiveorder()
  {
   canbuy=0;
   cansell=0;
//---
   for(int i = 0 ; i < OrdersTotal() ; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
        {
         Print("ERROR - Unable to select the order - ",GetLastError());
         break;
        }
      if(OrderSymbol()==Symbol() && (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP ))
         canbuy++;
      if(OrderSymbol()==Symbol() && (OrderType() == OP_SELL ||OrderType() == OP_SELLSTOP) )
         cansell++;
     }
  }
//========================================================================================================================================================================//
double calculateLotSize(double stopLoss,double Risk)
  {
// Fetch some symbol properties
   double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double minLot  = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
   double tickVal = MarketInfo(Symbol(), MODE_TICKVALUE);
// Calculate the actual lot size
   double lotSize = AccountBalance() * Risk / 100 / (stopLoss * tickVal);
//---
   return MathMin(
             maxLot,
             MathMax(
                minLot,
                NormalizeDouble(lotSize / lotStep, 0) * lotStep
             )
          );
  }
//========================================================================================================================================================================//
void opennew(int ordertype)
  {
   RefreshRates();
   double openprice;
   double closeprice=0;
   double stopp=0;
   double takep=0;
   bool OrdrSend=false;
   datetime experation=Time[0]+(2*(PeriodSeconds()));
//---
   if(ordertype==OP_BUYSTOP)
     {
      openprice=High[1]+2*10*Point;
      stopp=openprice-(sl*10*Point);
      takep=openprice+(tp*10*Point);
     }
//---
   if(ordertype==OP_SELLSTOP)
     {
      openprice=Low[1]-2*10*Point;
      stopp=openprice+(sl*10*Point);
      takep=openprice-(tp*10*Point);
     }
//---
   OrdrSend=OrderSend(Symbol(),ordertype,calculateLotSize(sl*10,risk),openprice,10,NormalizeDouble(stopp,Digits),NormalizeDouble(takep,Digits),NULL,0,experation,clrBlue);
  }
//========================================================================================================================================================================//
void checkorderstatues(){
double openprice ;double stopp,takep;
for(int i = 0 ; i < OrdersTotal() ; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
        {
         Print("ERROR - Unable to select the order - ",GetLastError());
         break;
        }
      if(OrderSymbol()==Symbol() && OrderType() == OP_BUYSTOP )
         if(High[1]<OrderOpenPrice())
            {
            openprice=High[1];
            stopp=openprice-sl*10*Point;
            takep=openprice+tp*10*Point;
            OrderModify(OrderTicket(),openprice,stopp,takep,0,clrBlueViolet);}
         
      if(OrderSymbol()==Symbol() && OrderType() == OP_SELLSTOP )
         if(Low[1]>OrderOpenPrice())
            {
            openprice=Low[1];
            stopp=openprice+sl*10*Point;
            takep=openprice-tp*10*Point;
            OrderModify(OrderTicket(),openprice,stopp,takep,0,clrBlueViolet);}
         

}}
//================================================================================================================================
void cheackmacross()
  {
   crossup=false;
   crossdown=false;
//---
   double currMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,1);
   double prevMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,2);
   double currMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,1);
   double prevMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,2);
   double currMA3=iMA(Symbol(),0,ma3,0,MODE_EMA,PRICE_CLOSE,1);
   double prevMA3=iMA(Symbol(),0,ma3,0,MODE_EMA,PRICE_CLOSE,2);
   double currMA4=iMA(Symbol(),0,ma4,0,MODE_SMA,PRICE_CLOSE,1);
   double prevMA4=iMA(Symbol(),0,ma4,0,MODE_SMA,PRICE_CLOSE,2);
   

//---
   if(prevMA2>prevMA1 && currMA1>currMA2 && currMA1>currMA4 && currMA1>currMA3 && prevMA1>prevMA4 && prevMA1>prevMA3 )
     {
      crossup=true;
     }
//---
   if(prevMA1>prevMA2 && currMA2>currMA1 && currMA1<currMA4 && currMA1<currMA3 && prevMA1<prevMA4 && prevMA1<prevMA3)
     {
      crossdown=true;
     }

  }
//========================================================================================================================================================================//
bool isthisthisnewcandle(){
static int barsonchart=0;
if (Bars==barsonchart)
return (false);
barsonchart=Bars;
return(true);}
//========================================================================================================================================================================//
bool isthiscandleswingh(){
 highestprevbar = High[iHighest(Symbol(),0,MODE_HIGH,9,1)];
    currentcandleh=High[1];                 //check if cuurent candle is the hiest of previos 8 
   if ((currentcandleh>=highestprevbar) && checkbuycondition==true){     
        swinghighattempts++ ;
       return true;
   }

return false;
}
//========================================================================================================================================================================//

bool isthiscandleswingl(){
 lowestprevbar = Low[iLowest(Symbol(),0,MODE_LOW,9,1)];
    currentcandlel=Low[1];                 //check if cuurent candle is the hiest of previos 8 
   if ((currentcandlel<=lowestprevbar)&& checksellcondition==true){
   swinglowattempts++;
   return true;   
}
return false;
}
//===============================================================================================================================
bool isthispullbackl()
{
if ((High[1]>High[2] && Low[1]>Low[2])&& checksellcondition==true){
pullbacklowattampt++;
return true;}
return false;
}
//==============================================================================================================================
bool isthispullbackh()
{
if ((High[1]<High[2] && Low[1]<Low[2]) && checkbuycondition==true){
        pullbackhighattampt++;
        return true;}
return false;
}
//===============================================================================================================================
bool isthisinsidebar()
{
if (High[1]<High[2] && Low[1]>Low[2])return true;
 return false;
}
//===============================================================================================================================
string nametype;
void drawlabel(int chart_ID, string name,int x,int y,ENUM_BASE_CORNER corner,string text,int font_size,color clr,bool selection,bool hidden){
nametype=name;
ObjectCreate(name,OBJ_LABEL,0,0,0);
ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set the slope angle of the text
//   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- set anchor type
//   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- set color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- display in the foreground (false) or background (true)
//   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the label by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
//   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
return; }
void ArrowCreate(ENUM_OBJECT direction,string name,datetime time,double price ,int chart_ID ,color clr,int width,bool back,bool selection,bool hidden,int z_order)            
  {
ObjectCreate(chart_ID,name,direction,0,time,price);
//--- set anchor type
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,ANCHOR_BOTTOM);
//--- set a sign color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set the border line style
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,STYLE_SOLID);
//--- set the sign size
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the sign by mouse
//--- when creating a graphical object using ObjectCreate function, the object cannot be
//--- highlighted and moved by default. Inside this method, selection parameter
//--- is true by default making it possible to highlight and move the object
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);

 }
void del(string labelstatues)
{
//if (nametype=="BUY INFO")ObjectDelete(0,"BUY INFO");
//if (nametype=="SELL INFO")ObjectDelete(0,"SELL INFO");
ObjectDelete(0,labelstatues);
}
